using System;
using System.Collections.Generic;
using System.Text;

using Core.LJElements;

namespace Core
{
	/// <summary>
	///      
	/// </summary>
	public static class KeywordsManager
	{
		public static List<string> FromString (string str)
		{
			List<string> result = new List<string> ();

			string[] keywords = str.Split (",".ToCharArray ());
			for (int i = 0; i < keywords.Length; i++)
			{
				result.Add (keywords[i].Trim ().ToLower ());
			}

			return result;
		}

		public static string ToString (List<string> keywords)
		{
			string result = "";
			for (int i = 0; i < keywords.Count; i++)
			{
				if (i != 0)
				{
					result += ", ";
				}

				result += keywords[i];
			}

			return result;
		}

		public static List<string> GetAllKeywords (Document doc)
		{
			List<string> result = new List<string> ();

			if (doc != null)
			{
				for (int i = 0; i < doc.Count; i++)
				{
					if (doc[i].Keywords != null)
					{
						for (int j = 0; j < doc[i].Keywords.Count; j++)
						{
							if (result.IndexOf (doc[i].Keywords[j]) == -1)
							{
								result.Add (doc[i].Keywords[j]);
							}
						}
					}
				}

				result.Sort ();
			}
			return result;
		}
	}
}
