﻿using System;
using System.Collections.Generic;
using System.Text;

using Core.Exceptions;

namespace Core.LJElements
{
	/// <summary>
	/// Сообщение
	/// </summary>
	[Serializable]
	public class Post: MessageBase
	{
		private UserInfo _community = new UserInfo ();
		public UserInfo Community
		{
			get
			{
				return _community;
			}

			set
			{
				_community = value;
			}
		}

		/// <summary>
		/// Теги из поста
		/// </summary>
		private List<string> _tags = new List<string> ();

		/// <summary>
		/// Теги из поста
		/// </summary>
		public List<string> Tags
		{
			get
			{
				return _tags;
			}

			set
			{
				_tags = value;
			}
		}

		/// <summary>
		/// Ключевые слова, присвоенные посту
		/// </summary>
		private List<string> _keywords = new List<string> ();

		/// <summary>
		/// Ключевые слова, присвоенные посту
		/// </summary>
		public List<string> Keywords
		{
			get { return _keywords; }
			set { _keywords = value; }
		}


		public override int Level
		{
			set
			{
				throw new EditPostLevelException ();
			}
		}

		/// <summary>
		/// Обновляемый пост?
		/// </summary>
		bool _disabled = false;

		/// <summary>
		/// Обновляемый пост?
		/// </summary>
		public bool Disabled
		{
			get { return _disabled; }
			set { _disabled = value; }
		}

		/// <summary>
		/// Использовать куки для авторизации?
		/// </summary>
		bool _useCookies = false;

		public bool UseCookies
		{
			get { return _useCookies; }
			set { _useCookies = value; }
		}
	}
}
