﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Windows.Forms;

using Core.LJElements;
using System.Net;

namespace Core
{
	public static class MainFunctions
	{
		public static void RemoveSelectedPost(Document doc)
		{
			if (doc.SelectedIndex != -1)
			{
				if (MessageBox.Show ("Вы уверены, что хотите удалить пост из списка?", "Вы уверены?",
					MessageBoxButtons.YesNo, MessageBoxIcon.Question) == DialogResult.Yes)
				{
					doc.RemovePost (doc.SelectedIndex);
				}
			}
		}


		public static WebProxy GetProxy ()
		{
			WebProxy proxy = null;

			if (Config.Instance.UseProxy)
			{
				string proxyUrl = Config.Instance.ProxyAddress;
				int proxyPort = Config.Instance.ProxyPort;

				if (!proxyUrl.StartsWith ("http://"))
				{
					proxyUrl = "http://" + proxyUrl;
				}

				if (proxyUrl.EndsWith ("/"))
				{
					proxyUrl = proxyUrl.Substring (0, proxyUrl.Length - 1);
				}

				proxy = new WebProxy (string.Format ("{0}:{1}/", proxyUrl, proxyPort));
			}
			return proxy;
		}
	}
}
