using System;
using System.Collections.Generic;
using System.Text;

using Core.LJElements;

namespace Core
{
	/// <summary>
	///    
	/// </summary>
	public class SelectedPost
	{
		public Post Post;
		
		/// <summary>
		///    
		/// </summary>
		public int SrcNumber;

		public SelectedPost (Post post, int srcNumber)
		{
			this.Post = post;
			this.SrcNumber = srcNumber;
		}
	}	

	[Serializable]
	public enum PostType
	{
		All = 0,
		Updated = 1,
		Unread = 2
	};

	/// <summary>
	///      ,   
	/// </summary>	
	public static class PostFilter
	{
		/// <summary>
		///    ,  
		/// </summary>
		/// <param name="doc"></param>
		/// <param name="type"></param>
		/// <param name="keyword"> . 
		///        , keyword    </param>
		/// <returns>  </returns>
		public static SelectedPost[] SelectPosts (Document doc, PostType type, string keyword)
		{
			List<SelectedPost> result = new List<SelectedPost> ();
			for (int i = 0; i < doc.Count; i++)
			{
				if (CheckPostType (doc[i], type) && 
					(keyword.Length == 0 || 
						(doc[i].Keywords != null && doc[i].Keywords.IndexOf (keyword) != -1) ) )
				{
					result.Add (new SelectedPost (doc[i], i));
				}
			}

			return result.ToArray ();
		}

		private static bool CheckPostType (Post post, PostType type)
		{
			switch (type)
			{
				case PostType.Updated:
					return !post.Disabled;
				case PostType.Unread:
					return post.IsNewCommentsParent;
				default:
					return true;
			}
		}
	}
}
