using System;
using System.Collections.Generic;
using System.Text;
using System.Collections.Specialized;
using System.Web;
using System.Net;

namespace Core
{
	public class FlatLJServer: LJServer
	{
		public FlatLJServer ()
			:base ()
		{
		}

		/// <summary>
		///        
		/// </summary>
		/// <param name="response"></param>
		/// <returns></returns>
		private StringDictionary MakeDict (string response)
		{
			string[] split = response.Split ("\n".ToCharArray ());

			StringDictionary dict = new StringDictionary();
			for (int i = 0; i < split.Length - 1; i += 2)
			{
				dict[split[i]] = split[i + 1];
			}

			return dict;
		}

		public override string ServerUri
		{
			get { return "http://www.livejournal.com/interface/flat"; }
		}

		public override string ContentType
		{
			get { return "application/x-www-form-urlencoded"; }
		}

		public override string GetChallenge ()
		{
			string request = "mode=getchallenge";
			string challengeResponse = SendRequest (request);

			StringDictionary dict = MakeDict (challengeResponse);
			if (dict["success"] == "OK")
			{
				return dict["challenge"];
			}

			return "";
		}
	}
}
