using System;
using System.Collections.Generic;
using System.Text;
using System.Security.Cryptography;

using System.Security;
using System.Net;
using System.IO;
using System.Web;

using Core.Log;

namespace Core
{
	public abstract class LJServer
	{
		public abstract string GetChallenge ();

		//ILog _log;

		//WebProxy _proxy = null;

		/*public WebProxy Proxy
		{
			get { return _proxy; }
			set { _proxy = value; }
		}*/

		public LJServer ()
		{
			//_log = log;
		}

		private CookieCollection _cookies = new CookieCollection ();

		public CookieCollection Cookies
		{
			get { return _cookies; }
			set { _cookies = value; }
		}

		/// <summary>
		///   
		/// </summary>
		public abstract string ServerUri
		{
			get;
		}

		public abstract string ContentType
		{
			get;
		}


		/// <summary>
		///   cookies     
		/// </summary>
		/// <param name="login"> </param>
		/// <param name="password"></param>
		/// <returns>  cookies</returns>
		public CookieCollection GetBaseCookie (string login, string password)
		{
			string lj_login_chal = GetChallenge ();

			//       challenge / response
			string auth_response = GetAuthResponse (password, lj_login_chal);

			//      
			string textRequest = string.Format ("chal={0}&response={1}&user={2}",
				HttpUtility.UrlEncode (lj_login_chal),
				HttpUtility.UrlEncode (auth_response),
				HttpUtility.UrlEncode (login));			 
			 
			byte[] byteArray = Encoding.UTF8.GetBytes (textRequest);

			//   
			HttpWebRequest request =
				(HttpWebRequest)WebRequest.Create ("http://www.livejournal.com/login.bml");

			//   
			request.Method = "POST";

			//   ,   cookies,      
			request.AllowAutoRedirect = false;
			request.ContentType = "application/x-www-form-urlencoded";
			request.ContentLength = textRequest.Length;
			request.UserAgent = "LJWatcher";

			//     cookie    
			request.CookieContainer = new CookieContainer ();

			//   Proxy (_proxy == null,    )
			//request.Proxy = _proxy;
			request.Proxy = MainFunctions.GetProxy ();

			//   
			Stream requestStream = request.GetRequestStream ();
			requestStream.Write (byteArray, 0, textRequest.Length);

			//   
			HttpWebResponse response = (HttpWebResponse)request.GetResponse ();

			//  
			Stream responseStream = response.GetResponseStream ();
			StreamReader readStream = new StreamReader (responseStream, Encoding.UTF8);

			string currResponse = readStream.ReadToEnd ();

			readStream.Close ();
			response.Close ();

			//     cookies
			CookieCollection newCollection = new CookieCollection ();
			for (int i = 0; i < response.Cookies.Count; i++)
			{
				/*if (response.Cookies[i].Name == "ljloggedin" ||
					response.Cookies[i].Name == "ljmastersession")
				{
					newCollection.Add (response.Cookies[i]);
				}*/

				newCollection.Add (response.Cookies[i]);
			}

			return newCollection;
		}

		/// <summary>
		///  md5.   lj.net. http://lj-net.cvs.sourceforge.net/lj-net/lj-net/Utils.cs?view=markup
		/// </summary>
		/// <param name="text"></param>
		/// <returns></returns>
		protected string ComputeMD5(string text)
		{
			MD5CryptoServiceProvider md5 = new MD5CryptoServiceProvider ();
			byte[] hashBytes = md5.ComputeHash( Encoding.UTF8.GetBytes( text ) );

			StringBuilder sb = new StringBuilder();

			foreach( byte hashByte in hashBytes )
				sb.Append( Convert.ToString( hashByte, 16 ).PadLeft( 2, '0' ) );

			return sb.ToString();
		}

		/// <summary>
		///    
		/// </summary>
		/// <param name="password"></param>
		/// <param name="challenge"></param>
		/// <returns></returns>
		protected string GetAuthResponse (string password, string challenge)
		{
			// md5  
			string hpass = ComputeMD5 (password);

			string constr = challenge + hpass;
			string auth_response = ComputeMD5 (constr);

			return auth_response;
		}

		protected string SendRequest (string textRequest)
		{
			//      byte[]
			byte[] byteArray = Encoding.UTF8.GetBytes (textRequest);

			//   
			HttpWebRequest request = (HttpWebRequest)WebRequest.Create (ServerUri);

			//   
			request.Credentials = CredentialCache.DefaultCredentials;
			request.Method = "POST";
			request.ContentLength = textRequest.Length;
			request.ContentType = this.ContentType;
			request.UserAgent = "LJWatcher";

			//     cookie    
			request.CookieContainer = new CookieContainer ();
			request.CookieContainer.Add (_cookies);

			//   Proxy (_proxy == null,    )
			request.Proxy = MainFunctions.GetProxy ();

			//   cookie   "ljsession",      
			//      "X-LJ-Auth"   "cookie"
			if (_cookies["ljsession"] != null)
			{
				request.Headers.Add ("X-LJ-Auth", "cookie");
			}

			//   
			Stream requestStream = request.GetRequestStream ();
			requestStream.Write (byteArray, 0, textRequest.Length);

			//   
			HttpWebResponse response = (HttpWebResponse)request.GetResponse ();

			//  
			Stream responseStream = response.GetResponseStream ();
			StreamReader readStream = new StreamReader (responseStream, Encoding.UTF8);

			string currResponse = readStream.ReadToEnd ();

			_cookies = response.Cookies;

			readStream.Close ();
			response.Close ();

			return currResponse;
		}
	}
}
