﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.IO;
using System.Net;
using System.Security.Cryptography;

using Core;
using Core.Log;
using Core.LJElements;
using LJWatcher.Gui;

namespace LJTest
{
	public partial class Form1 : Form
	{
		ILog _log;
		PostLoader _loader;

		HtmlTemplate _template;

		LJClient _client = new LJClient ();

		public Form1()
		{
			InitializeComponent ();

			_log = new TextLog (logText);

			string dir = Path.Combine ( Path.GetDirectoryName (Application.ExecutablePath), 
				"templates\\lj\\");
			_template = new HtmlTemplate (dir);
			postThree.Template = _template;

			Config.Instance.ProxyAddress = "localhost";
			Config.Instance.ProxyPort = 8080;
			Config.Instance.UseProxy = false;
		}

		private void ClearLog_Click(object sender, EventArgs e)
		{
			_log.Clear ();
		}

		private void GetContent_Click(object sender, EventArgs e)
		{
			//ContentExtractor cont = new ContentExtractor (_source);
			//_content = cont.ToString ();

			//_log.WriteLine (_loader.Content);

			ILog log = new TextLog (logText);
			log.WriteLine (_loader.Content);
		}

		
		private void elements_Click(object sender, EventArgs e)
		{
			ILog log = new TextLog (logText);
			Post post = _loader.LoadedPost;

			//log.WriteLine ("Subj: " + post.Subj);
			//log.WriteLine (post.MainMessage + "\r\n");

			OutputComment (post, log, 1);
		}

		private void OutputComment(MessageBase comment, ILog log, int space)
		{
			string spaceStr = "";
			for (int i = 0; i < space; ++i )
			{
				spaceStr += "    ";
			}

			log.WriteLine (spaceStr + "Level: " + comment.Level.ToString ());
			log.WriteLine (spaceStr + "Subj: " + comment.Subj);
			log.WriteLine (spaceStr + "User: " + comment.Info.UserInformation.UserName);
			log.WriteLine (spaceStr + comment.MainMessage);

			Comment[] comments = comment.Comments;

			for (int i = 0; i < comments.Length; ++i)
			{
				OutputComment (comments[i], log, space + 1);
			}
		}

		private void load_Click(object sender, EventArgs e)
		{
			_loader = new PostLoader (source.Text, _log, _client.Cookies);
		}

		private void read_Click(object sender, EventArgs e)
		{
			_loader.LoadedPost.SetThreadRead (true);
		}

		private void auth_Click(object sender, EventArgs e)
		{
			_client = new LJClient ();

			bool logres = false;

			try
			{
				logres = _client.Login ();

				//_log.WriteLine (_client.LoginResponse);
			}
			catch (WebException we)
			{
				_log.WriteLine ("Ошибка подключения\r\n");
				_log.WriteLine (we.Message);
			}

			if (logres)
			{
				_log.WriteLine ("Login Success");
			}

		}
	}
}