using System;
using System.Collections.Generic;
using System.Text;
using System.IO;
using System.Net;
using System.Threading;

using Core;
using Core.LJElements;
using Core.Log;

namespace LJWatcher
{
	internal class ContentUpdater
	{
		/// <summary>
		///  
		/// </summary>
		UpdateThreadParams _params;

		ILog _log;

		/// <summary>
		///  
		/// </summary>
		UpdateThreadParams.PostPosition[] _result;

		/// <summary>
		///   
		/// </summary>
		ManualResetEvent[] _resetEvents;

		public UpdateThreadParams.PostPosition[] Result
		{
			get { return _result; }
		}

		bool _success = false;

		public bool Success
		{
			get { return _success; }
		}

		public ContentUpdater (UpdateThreadParams param)
		{
			_params = param;
			_log = _params.log;
		}

		class UpdateParam
		{
			public readonly int Index;

			public UpdateParam (int index)
			{
				Index = index;
			}
		}

		void DoSingleUpdate (object data)
		{
			UpdateParam updateParam = (UpdateParam)data;

			int index = updateParam.Index;

			try
			{
				PostLoader loader;

				/*if (_params.IsLogin)
				{
					loader = new PostLoader (_params[index].post.Url, _log, _params.Cookies);
				}
				else
				{
					loader = new PostLoader (_params[index].post.Url, _log, null);
				}*/

				loader = new PostLoader (_params[index].post.Url, _log, _params.Cookies);

				lock (_result)
				{
					_result[index] = new UpdateThreadParams.PostPosition
						(loader.LoadedPost, _params[index].index);
				}

				/*_log.WriteLine (String.Format (" {0} ({1}) ",
					_params[i].index + 1, _params[i].post.Subj));
				_log.WriteLine ("");*/
			}
			catch (WebException exc)
			{
				_log.WriteLine (exc.Message);
				_success = false;
			}
			catch (FormatException)
			{
				_log.WriteLine ("   " + _params[index].post.Url);
				_success = false;
			}
			catch (IOException)
			{
				_log.WriteLine ("   " + _params[index].post.Url);
				_success = false;
			}

			_resetEvents[index].Set ();
		}


		public void StartUpdate ()
		{
			_success = true;
			_result = new UpdateThreadParams.PostPosition[_params.Count];

			if (_params.Count == 0)
			{
				return;
			}

			Thread[] threads = new Thread[_params.Count];
			_resetEvents = new ManualResetEvent[_params.Count];

			for (int i = 0; i < _params.Count; i++)
			{
				_resetEvents[i] = new ManualResetEvent (false);

				threads[i] = new Thread (new ParameterizedThreadStart (DoSingleUpdate));
				threads[i].IsBackground = true;
				
				threads[i].Start (new UpdateParam (i));
			}

			
			/*for (int i = 0; i < _params.Count; i++)
			{
				threads[i].Join ();
			}*/

			//WaitHandle.WaitAll (_resetEvents, -1, false);

			while (!WaitHandle.WaitAll (_resetEvents, 500, true))
			{
				if (_params.BackWorker.CancellationPending)
				{
					for (int i = 0; i < _params.Count; i++)
					{
						//if (threads[i].ThreadState == ThreadState.Running)
						//{
							threads[i].Abort ();
							_resetEvents[i].Set ();
						//}
					}

					break;
				}
			}

		}
	}
}
