﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

using Core.LJElements;

namespace LJWatcher.Gui.Dialogs
{
	public partial class AddDialog : Form
	{
		public AddDialog (Document doc)
		{
			InitializeComponent ();

			keywordsEditor.FillKeywords (doc);

			try
			{
				string text = GetUrl(Clipboard.GetText());

				if (text.LastIndexOf ("livejournal.com") != -1)
				{
					url.Text = text;
				}
			}
			catch (FormatException)
			{
			}
		}

		public List<string> Keywords
		{
			get { return keywordsEditor.Keywords; }
		}


		string GetUrl (string text)
		{
			string res = text;

			string html = ".html";
			int pos = res.LastIndexOf (".html");

			if (pos == -1)
			{
				throw new FormatException ();
			}

			return text.Substring (0, pos + html.Length);		
		}

		public string Url
		{
			get
			{
				return GetUrl (url.Text);
			}

			set
			{
				url.Text = value;
			}
		}

		private void ok_Click(object sender, EventArgs e)
		{
			errorProvider.SetError (url, "");

			try
			{
				string strUrl = Url;
			}
			catch (FormatException)
			{
				errorProvider.SetError (url, "Вы ввели неправильную сылку");
				return;
			}

			this.DialogResult = DialogResult.OK;
			Close ();
		}
	}
}