﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

using Core;
using LJWatcher.Gui;

namespace LJWatcher.Gui.Dialogs
{
	public partial class ConfigDialog : Form
	{
		public ConfigDialog()
		{
			InitializeComponent ();

			useProxy.Checked = Config.Instance.UseProxy;
			proxyAddress.Text = Config.Instance.ProxyAddress;
			proxyPort.Text = Config.Instance.ProxyPort.ToString ();

			templateDir.Text = Config.Instance.TemplateDir;

			autoupdate.Checked = Config.Instance.AutoUpdate;
			updateInterval.Value = Config.Instance.AutoUpdateInterval;

			gotoNewComment.Checked = Config.Instance.GotoNewComment;
			showLogTime.Checked = Config.Instance.ShowLogTime;

			disableOldPost.Checked = Config.Instance.DisableOldPost;
			daysCount.Value = Config.Instance.OldPostDays;
		}

		private void proxyPort_Validating(object sender, CancelEventArgs e)
		{
			errorProvider.SetError (proxyPort, "");

			try
			{
				int port = int.Parse (proxyPort.Text);
			}
			catch (FormatException)
			{
				errorProvider.SetError (proxyPort, "Не правильно задан порт");
			}
		}

		private void ConfigDialog_Load(object sender, EventArgs e)
		{
		}

		HtmlTemplate _newTemplate = null;

		public HtmlTemplate NewTemplate
		{
			get
			{
				return _newTemplate;
			}
		}

		private void ok_Click(object sender, EventArgs e)
		{
			if (errorProvider.GetError (proxyPort).Length == 0)
			{
				try
				{
					_newTemplate = new HtmlTemplate (templateDir.Text);
					Config.Instance.TemplateDir = templateDir.Text;
				}
				catch (Exception)
				{
					MessageBox.Show ("Не могу загрузить шаблон", "Ошибка загрузки шаблона",
						 MessageBoxButtons.OK, MessageBoxIcon.Error);
					return;
				}

				Config.Instance.ProxyPort = int.Parse (proxyPort.Text);
				Config.Instance.ProxyAddress = proxyAddress.Text;
				Config.Instance.UseProxy = useProxy.Checked;
				Config.Instance.AutoUpdate = autoupdate.Checked;
				Config.Instance.AutoUpdateInterval = (int)updateInterval.Value;
				Config.Instance.GotoNewComment = gotoNewComment.Checked;
				Config.Instance.ShowLogTime = showLogTime.Checked;

				Config.Instance.OldPostDays = (int)daysCount.Value;
				Config.Instance.DisableOldPost = disableOldPost.Checked;

				this.DialogResult = DialogResult.OK;
				this.Close ();
			}
		}

		private void browseDir_Click(object sender, EventArgs e)
		{
			if (folderBrowserDialog.ShowDialog() == DialogResult.OK)
			{
				templateDir.Text = folderBrowserDialog.SelectedPath;
			}
		}
	}
}