using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Text;
using System.Windows.Forms;

using Core;
using Core.LJElements;

namespace LJWatcher.Gui
{
	public partial class KeywordsEditor : UserControl
	{
		public KeywordsEditor ()
		{
			InitializeComponent ();
		}

		List<string> _keywords;

		public void FillKeywords (Document doc)
		{
			_keywords = KeywordsManager.GetAllKeywords (doc);
		}

		public List<string> Keywords
		{
			get
			{
				return KeywordsManager.FromString (keywordsText.Text);
			}

			set
			{
				if (value != null)
				{
					_keywords = value;
				}
				else
				{
					_keywords = new List<string> ();
				}

				keywordsText.Text = KeywordsManager.ToString (_keywords);
			}
		}
	}
}
