﻿using System;
using System.ComponentModel;
using System.Text;
using System.Windows.Forms;

namespace LJWatcher.Gui
{
	public partial class LongTimer : Component
	{
		public LongTimer()
		{
			InitializeComponent ();

			_timer.Interval = 500;
		}

		public LongTimer(IContainer container)
		{
			container.Add (this);

			InitializeComponent ();

			_timer.Interval = 5000;
			_timer.Tick += new EventHandler(_timer_Tick);
		}

		void _timer_Tick(object sender, EventArgs e)
		{
			if (DateTime.Now >= _RunDate)
			{
				OnLongTimerTick (new LongTimerTickEventArgs ());
			}
		}

		/// <summary>
		/// Интервал в минутах
		/// </summary>
		int _interval = 5;

		public int Interval
		{
			get
			{
				return _interval;
			}

			set
			{
				if (_interval != value)
				{
					_RunDate = DateTime.Now.AddMinutes (value);
				}

				_interval = value;
			}
		}

		Timer _timer = new Timer ();

		/// <summary>
		/// Когда пора звонить
		/// </summary>
		DateTime _RunDate;

		public void Start()
		{
			_timer.Stop ();

			_RunDate = DateTime.Now.AddMinutes (_interval);

			_timer.Start ();
		}

		public void Stop()
		{
			_timer.Stop ();
		}

		#region Тик таймера

		public class LongTimerTickEventArgs : EventArgs
		{
		}

		public delegate void LongTimerTickEventHandler(Object sender, LongTimerTickEventArgs args);

		public event LongTimerTickEventHandler LongTimerTick;

		protected virtual void OnLongTimerTick(LongTimerTickEventArgs e)
		{
			if (LongTimerTick != null)
			{
				LongTimerTick (this, e);
			}
		}

		#endregion
	}
}
