using System;
using System.Collections.Generic;
using System.Text;
using System.Windows.Forms;

namespace LJWatcher.Gui.NewCommentsNotify
{
	public class TrayNotify: INotifer
	{
		NotifyIcon _tray;

		public TrayNotify (NotifyIcon tray)
		{
			_tray = tray;
			_tray.BalloonTipTitle = "   :";
			_tray.BalloonTipText = "";
		}

		#region INotifer Members

		public void AddPost (Core.LJElements.Post newPost)
		{
			string text = string.Format ("{0} ({1})", 
				newPost.Subj.Length == 0 ? "---" : newPost.Subj,
				newPost.NewCommentsCount);

			if (_tray.BalloonTipText.Length == 0)
			{
				_tray.BalloonTipText = text;
			}
			else
			{
				_tray.BalloonTipText += "\r\n" + text;
			}

			_tray.ShowBalloonTip (5000);
		}

		#endregion
	}
}
