﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

using Core.LJElements;

namespace LJWatcher.Gui
{
	public partial class PostInfoDialog : Form
	{
		Post _post = null;
		Document _doc;

		public PostInfoDialog(Document doc, Post post)
		{
			InitializeComponent ();

			_post = post;
			_doc = doc;

			link.Text = _post.Url;
			subj.Text = _post.Subj;
			author.Text = _post.Info.UserInformation.UserName;
			community.Text = _post.Community.UserName;
			lastUpdate.Text = _post.LastUpdate.ToString ();
			keywordsEditor.Keywords = _post.Keywords;

			updateThis.Checked = !_post.Disabled;

			//useCookies.Checked = _post.UseCookies;

			keywordsEditor.FillKeywords (doc);
		}

		private void ok_Click(object sender, EventArgs e)
		{
			this.DialogResult = DialogResult.OK;

			_post.Disabled = !updateThis.Checked;
			//_post.UseCookies = useCookies.Checked;
			_post.Subj = subj.Text;
			_post.Keywords = keywordsEditor.Keywords;

			_doc.GeneratePostListChangeEvent ();
			this.Close ();
		}

	}
}