﻿using System;
using System.Collections.Generic;
using System.Windows.Forms;
using System.Threading;
using System.IO;
using System.Runtime.InteropServices;

namespace LJWatcher
{
	static class Program
	{
		[DllImport ("user32.dll")]
		static extern bool ShowWindow(IntPtr hWnd, int nCmdShow);

		const int ShowNormal = 1;

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main()
		{
			//////////////////////////////////////////////////////////////////////////
			// Проверка запуска второго экземпляра из той же папки

			string mutexName;
			Mutex mutex = null;
			mutexName = "LJWatcherMutex";

			bool newMutex;
			mutex = new Mutex (true, mutexName, out newMutex);

			if (newMutex)
			{
				Application.EnableVisualStyles ();
				Application.SetCompatibleTextRenderingDefault (false);
				Application.Run (new MainForm ());

				if (mutex != null)
				{
					mutex.ReleaseMutex ();
				}
			}
			else
			{
				string RunDataFileName = 
					Path.Combine (Path.GetDirectoryName (Application.ExecutablePath), "rundata.dat");

				try
				{
					using (FileStream fs = File.OpenRead (RunDataFileName))
					using (BinaryReader reader = new BinaryReader (fs))
					{
						Int32 handle = reader.ReadInt16 ();
						ShowWindow ((IntPtr)handle, ShowNormal);
					}
				}
				catch (FileNotFoundException)
				{

				}
			}
		}
	}
}